import type { Either } from '@lokalise/node-core';
import type { BarrierResult, MessageInvalidFormatError, MessageValidationError } from '@message-queue-toolkit/core';
import { AbstractAmqpService } from './AbstractAmqpService';
export declare abstract class AbstractAmqpBasePublisher<MessagePayloadType extends object> extends AbstractAmqpService<MessagePayloadType> {
    protected sendToQueue(message: MessagePayloadType): void;
    protected resolveMessage(): Either<MessageInvalidFormatError | MessageValidationError, unknown>;
    protected processPrehandlers(): Promise<unknown>;
    protected preHandlerBarrier(): Promise<BarrierResult<unknown>>;
    protected resolveNextFunction(): () => void;
    processMessage(): Promise<Either<'retryLater', 'success'>>;
}
