"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AbstractAmqpConsumerMonoSchema = void 0;
const AbstractAmqpBaseConsumer_1 = require("./AbstractAmqpBaseConsumer");
const DEFAULT_BARRIER_RESULT = {
    isPassing: true,
    output: undefined,
};
class AbstractAmqpConsumerMonoSchema extends AbstractAmqpBaseConsumer_1.AbstractAmqpBaseConsumer {
    messageSchema;
    schemaEither;
    prehandlers;
    constructor(dependencies, options) {
        super(dependencies, options);
        this.prehandlers = options.prehandlers;
        this.messageSchema = options.messageSchema;
        this.schemaEither = {
            result: this.messageSchema,
        };
    }
    processPrehandlers(message, _messageType) {
        return this.processPrehandlersInternal(this.prehandlers, message);
    }
    // MonoSchema support is going away in the next semver major, so we don't care about coverage strongly
    /* c8 ignore start */
    // eslint-disable-next-line max-params
    resolveNextFunction(prehandlers, message, index, prehandlerOutput, resolve, reject) {
        return this.resolveNextPreHandlerFunctionInternal(prehandlers, this, message, index, prehandlerOutput, resolve, reject);
    }
    /* c8 ignore stop */
    resolveSchema(_message) {
        return this.schemaEither;
    }
    /**
     * Override to implement barrier pattern
     */
    preHandlerBarrier(_message) {
        // @ts-ignore
        return Promise.resolve(DEFAULT_BARRIER_RESULT);
    }
}
exports.AbstractAmqpConsumerMonoSchema = AbstractAmqpConsumerMonoSchema;
//# sourceMappingURL=AbstractAmqpConsumerMonoSchema.js.map