import type { Either } from '@lokalise/node-core';
import type { QueueConsumer, MultiSchemaConsumerOptions, BarrierResult, Prehandler, PrehandlingOutputs } from '@message-queue-toolkit/core';
import { HandlerContainer, MessageSchemaContainer } from '@message-queue-toolkit/core';
import type { NewAMQPConsumerOptions } from './AbstractAmqpBaseConsumer';
import { AbstractAmqpBaseConsumer } from './AbstractAmqpBaseConsumer';
import type { AMQPConsumerDependencies } from './AbstractAmqpService';
export declare abstract class AbstractAmqpConsumerMultiSchema<MessagePayloadType extends object, ExecutionContext, PrehandlerOutput = undefined, BarrierOutput = undefined> extends AbstractAmqpBaseConsumer<MessagePayloadType, ExecutionContext, PrehandlerOutput, BarrierOutput> implements QueueConsumer {
    messageSchemaContainer: MessageSchemaContainer<MessagePayloadType>;
    handlerContainer: HandlerContainer<MessagePayloadType, ExecutionContext, PrehandlerOutput>;
    protected readonly executionContext: ExecutionContext;
    constructor(dependencies: AMQPConsumerDependencies, options: NewAMQPConsumerOptions<MessagePayloadType, ExecutionContext, PrehandlerOutput> & MultiSchemaConsumerOptions<MessagePayloadType, ExecutionContext, PrehandlerOutput>, executionContext: ExecutionContext);
    protected resolveSchema(message: MessagePayloadType): Either<Error, import("zod").ZodType<MessagePayloadType, import("zod").ZodTypeDef, MessagePayloadType>>;
    processMessage(message: MessagePayloadType, messageType: string, prehandlingOutputs: PrehandlingOutputs<PrehandlerOutput, any>): Promise<Either<'retryLater', 'success'>>;
    protected resolveMessageLog(message: MessagePayloadType, messageType: string): unknown;
    protected processPrehandlers(message: MessagePayloadType, messageType: string): Promise<PrehandlerOutput>;
    protected resolveNextFunction(prehandlers: Prehandler<MessagePayloadType, ExecutionContext, unknown>[], message: MessagePayloadType, index: number, prehandlerOutput: PrehandlerOutput, resolve: (value: PrehandlerOutput | PromiseLike<PrehandlerOutput>) => void, reject: (err: Error) => void): (prehandlerResult: import("@message-queue-toolkit/core/dist/lib/queues/HandlerContainer").PrehandlerResult) => void;
    protected preHandlerBarrier(message: MessagePayloadType, messageType: string, prehandlerOutput: PrehandlerOutput): Promise<BarrierResult<BarrierOutput>>;
}
